#ifndef __ADDR_H
#define __ADDR_H

#include <sys/mman.h>
#include <xenctrl.h>
#include <stdint.h>
#include "linux_consts.h"

#ifdef XEN41
#define XCH xc_interface *
#else
#define XCH int
#endif

void* addr_trans(XCH xc_handle, int dom, int cpu, uint32_t flag, unsigned long addr, unsigned int size);

/* return the pointer to ptr->member */
#define GREF(ptr, member) \
    (void *)((char *)ptr + offsetof(typeof(*ptr), member))

#define ADDRX(ptr) \
    addr_trans(handle->xc_handle, handle->dom, handle->cpu, PROT_READ, \
               (uint64_t)ptr, sizeof(typeof(*ptr)))

#define ADDRX2(ptr, size) \
    addr_trans(handle->xc_handle, handle->dom, handle->cpu, PROT_READ, \
               (uint64_t)ptr, size)

/* return the pointer to ptr->member in mapped memory */
#define HREF(ptr, member) ({ \
    void *obj = GREF(ptr, member); \
    (typeof(((typeof(*ptr) *)0)->member) *)ADDRX(obj); })

/* return the value of ptr->member */
#define GDAT(ptr, member) \
    *HREF(ptr, member)

/*
#define container_of(ptr, type, member) ({                      \
        const typeof( ((type *)0)->member ) *__mptr = (ptr);    \
        (type *)( (char *)__mptr - offsetof(type,member) );})
*/

#ifndef MAP_ALL
#define UNMAP(ptr) /*unmap_pages(ptr, sizeof(typeof(*ptr)))*/
#else
#define UNMAP(ptr)  /* nop */
#endif

#endif /* __ADDR_H */
