#ifndef __ARRAY_H
#define __ARRAY_H

#include "linux_types.h"
#include "sched.h"
#include <stdio.h>

#ifdef __ASSEMBLY__
# define __ASM_FORM(x)	x
# define __ASM_EX_SEC	.section __ex_table
#else
# define __ASM_FORM(x)	" " #x " "
# define __ASM_EX_SEC	" .section __ex_table,\"a\"\n"
#endif

#ifdef CONFIG_X86_32
# define __ASM_SEL(a,b) __ASM_FORM(a)
#else
# define __ASM_SEL(a,b) __ASM_FORM(b)
#endif

#define _ASM_ALIGN	__ASM_SEL(.balign 4, .balign 8)

#ifdef CONFIG_SMP
#define LOCK_PREFIX \
		".section .smp_locks,\"a\"\n"	\
		_ASM_ALIGN "\n"			\
		_ASM_PTR "661f\n" /* address */	\
		".previous\n"			\
		"661:\n\tlock; "

#else /* ! CONFIG_SMP */
#define LOCK_PREFIX ""
#endif
clock_t jiffies_to_clock_t(long x);
int proc_pid_status(char *sp, struct task_struct *addr, struct sched_struct *handle);
int proc_tid_stat(char *sp, struct task_struct *addr, struct sched_struct *handle);
int proc_tgid_stat(char *sp, struct task_struct *addr, struct sched_struct *handle);
int proc_pid_statm(char *sp, struct pid_namespace *ns, struct pid *pid, struct task_struct *task, struct sched_struct *handle);
void task_mem(char *sp, struct mm_struct *mm);
struct task_struct *next_thread(struct task_struct *addr, struct sched_struct *handle);
#endif /* __ARRAY_H */
