#!/bin/bash

DATA=0

get_type()
{
CHECK=0
STRUCT=0
CNT=${3}

gdb ${1} --eval-command="ptype ${2}" -ex quit > tmp${3}.txt

while read line
do
RES=`echo ${line} | egrep "^type"`
if [ "${RES}" -a ${CHECK} -eq 0 ] ; then
	SED=`echo ${RES} | sed -e s/type\ =\ //g`
	if [ "${SED}" = "struct {" ]; then
		echo "typedef ${SED}" >> result${CNT}
		STRUCT[${3}]=1	
	elif [ "`echo ${SED} | grep "struct"`" -a "${SED}" != "${2} {" ] ; then
		echo "typedef ${SED}" >> result${CNT}
		STRUCT[${3}]=1
		CUT=`echo ${SED} | cut -d' ' -f1,2`
		ARRAY[${DATA}]="${CUT}"
		DATA=`expr ${DATA} + 1`
	elif [ "`echo ${SED} | grep {`" ] ; then
		echo "${SED}" >> result${CNT}
	elif [ "`echo ${SED} | grep enum`" ] ; then
		echo "${SED};" >> result${CNT}
		echo "" >> result${CNT}
	else
		echo "typedef ${SED} ${2};" >> result${CNT}
		ARRAY[${DATA}]="${2}"
		DATA=`expr ${DATA} + 1`
		echo "" >> result${CNT}
	fi
	CHECK=1

elif [ "`echo ${line} | grep }`" ] ; then
	if [ "${STRUCT[${3}]}" = "1" ] ; then
		echo "${line} ${2};" >> result${3}
		ARRAY[${DATA}]="${2}"
		DATA=`expr ${DATA} + 1`
	elif [ "`echo ${line} | grep \;`" ] ; then
		echo "${line}" >> result${3}
	else
		echo "${line};" >> result${3}
	fi
	echo "" >> result${3}

elif [ ${CHECK} -ne 0 ] ; then 
	CHECK=1
	if [ "`echo ${line} | egrep "int|unsigned|long|\*|double|char|void"`" ] ; then
		echo "    ${line}" >> result${3}
		continue
	elif [ "`echo ${line} | grep "no data fields"`" ] ; then
		continue
	fi	
	CUT=`echo ${line} | cut -d' ' -f1`

	case ${CUT} in
	"struct")
		CUT=`echo ${line} | cut -d' ' -f1,2`
		if [ "${CUT}" = "struct {" ] ; then
			echo "    ${line}" >> result${3}
			echo "" >> result${3}
			continue
		fi
		;;
	"const")
		CUT=`echo ${line} | cut -d' ' -f2,3`
		if [ "${CUT}" = "struct {" ] ; then
			echo "    ${line}" >> result${3}
			echo "" >> result${3}
			continue
		fi
		;;
	"union")
		CUT=`echo ${line} | cut -d' ' -f1,2`
		if [ "${CUT}" = "union {" ] ; then
			echo "    ${line}" >> result${3}
			echo "" >> result${3}
			continue
		fi
		;;	
	"enum")
		CUT=`echo ${line} | cut -d' ' -f1,2`
		;;
	*)
		;;
	esac
	ARG=0
	while [ ${ARG} -ne ${DATA} ]
	do
		if [ "${ARRAY[${ARG}]}" = "${CUT}" ] ; then
			CHECK=2
			break
		fi
		ARG=`expr ${ARG} + 1`
	done
	if [ ${CHECK} -ne 2 ] ; then
		ARRAY[${DATA}]="${CUT}"
		DATA=`expr ${DATA} + 1`
	fi
	echo "    ${line}" >> result${3}

	if [ "${CUT}" -a ${CHECK} -ne 2 ] ; then
		get_type ${1} "${CUT}" `expr ${CNT} + 1`
		CNT=$?
	fi
fi
done < tmp${3}.txt
rm tmp${3}.txt
cat result${3} >> linux_types.h
rm result${3}
echo -n "."
return ${CNT}
}

get_addr()
{
	while read symbol
	do
		gdb ${1} --eval-command="p &${symbol}" -ex quit | sed -e "s/ /\n/g"> addr.txt

		while read line
		do
			RES=`echo ${line} | grep 0x | cut -d')' -f2`
			if [ -n "${RES}" ] ; then
				ADDR_NAME=`echo ${symbol}_ADDR | tr "[a-z]" "[A-Z]"`
				echo "#define    ${ADDR_NAME}    ${RES}UL" >> linux_types.h
				break
			fi 
		done < addr.txt 
	done < symbol_list.cfg
	rm -f addr.txt
}

if [ $# -lt 1 ] ; then
	echo "usage: get_type.sh debug_kernel [type]"
	exit 1
fi
mv -f linux_types.h linux_types.h.bak
echo "#ifndef __LINUX_TYPES_H" > linux_types.h
echo "#define __LINUX_TYPES_H" >> linux_types.h
echo "" >> linux_types.h

if [ $# -eq 1 ]; then
    while read type
    do
        ARG=0
        FOUND=0
        while [ ${ARG} -ne ${DATA} ]
        do
	    if [ "${ARRAY[${ARG}]}" = "${type}" ] ; then
                FOUND=1
	        break
	    fi
	    ARG=`expr ${ARG} + 1`
        done

        if [ ${FOUND} -ne 1 ] ; then
            ARRAY[${DATA}]="${type}"
            DATA=`expr ${DATA} + 1`
            
            echo -n "obtaining ${type}"
            get_type "${1}" "${type}" "0"
            echo
        fi
    done < type_list.cfg

    echo "//from debug info" >> linux_types.h
    get_addr "${1}"
else
    ARRAY[${DATA}]="${2}"
    DATA=`expr ${DATA} + 1`

    get_type "${1}" "${2}" "0"
fi

echo "" >> linux_types.h
echo "#endif /* __LINUX_TYPES_H */" >> linux_types.h
echo "finish"
