#ifndef __LINUX_CONSTS_H
#define __LINUX_CONSTS_H

#define PAGE_SHIFT 12
#define PAGE_SIZE (1UL << PAGE_SHIFT)
#define PAGE_MASK (~(PAGE_SIZE-1))
#define PTRS_PER_PTE 512  /* 64bit */

#if 0
#define BITS_PER_LONG 64 /* 64bit */

#define CONFIG_X86_L1_CACHE_SHIFT 7
#define L1_CACHE_SHIFT  (CONFIG_X86_L1_CACHE_SHIFT)
#define L1_CACHE_BYTES  (1 << L1_CACHE_SHIFT)

#ifndef SMP_CACHE_BYTES
#define SMP_CACHE_BYTES L1_CACHE_BYTES
#endif
#endif

#define PT_PTRACED      0x00000001

#define PF_KTHREAD      0x00200000      /* I am a kernel thread */

/* linux/sched.h */
#define TASK_RUNNING            0
#define TASK_INTERRUPTIBLE      1
#define TASK_UNINTERRUPTIBLE    2
#define __TASK_STOPPED          4
#define __TASK_TRACED           8

#define TASK_REPORT             (TASK_RUNNING | TASK_INTERRUPTIBLE | \
                                 TASK_UNINTERRUPTIBLE | __TASK_STOPPED | \
                                 __TASK_TRACED)

#define NGROUPS_SMALL           32
#define NGROUPS_PER_BLOCK       ((unsigned int)(PAGE_SIZE / sizeof(gid_t)))

#endif /* __LINUX_CONSTS_H */
