#ifndef __SCHED_H
#define __SCHED_H

#include <stdint.h>
#include <stdio.h>
#include <sys/mman.h>
#include "linux_types.h"
#include "addr.h"

struct sched_struct {
  int cpu;
  XCH xc_handle;
  int dom;
  struct task_struct *init_task;
};

int sched_init(int dom, struct sched_struct* handle);
int sched_exit(struct sched_struct* handle);

struct task_struct* task_by_pid(struct sched_struct* handle, pid_t pid);
struct task_struct *next_task(struct task_struct *task, struct sched_struct *handle);
struct task_struct *get_task_struct(struct task_struct *addr, struct sched_struct *handle);
void init_task_info();
#endif /* __SCHED_H */
